package ga;


/**
 ** Diese Klasse reprsentiert ein einzelnens Chromosom, welches durch
 ** ein array von Integern dargestellt wird
 **
 ** 
 */
public class Chromosom_int
{
   int[] chrom;                 // Genotype - integer-array 
      
  
  /**
   ** Dieser Konstruktor erzeugt ein neues Chromosom.
   **
   */
  
   public Chromosom_int(int laenge)
   {
      int i;
      
      // erzeugen eines neuen Chromosoms durch kopieren
      chrom = new int [laenge];
      
      for (i=0; i<laenge; i++)
      	chrom[i] = i; 
   }

  
  
  /**
   ** Dieser Konstruktor erzeugt ein neues Chromosom.
   **
   */
  
   public Chromosom_int(int[] parent)
   {
      int i;
      
      // erzeugen eines neuen Chromosoms durch kopieren
      chrom = new int [parent.length];
      
      for (i=0; i<parent.length; i++)
      	chrom[i] = parent[i]; 
   }

  
  /**
   ** Dieser Konstruktor erzeugt ein neues Chromosom.
   **
   */
  
   public Chromosom_int(Chromosom_int parent)
   {
      int i;
            
      // erzeugen eines neuen Chromosoms durch kopieren
      chrom = new int [parent.length()];
      
      for (i=0; i<parent.length(); i++)
      	chrom[i] = parent.chrom()[i]; 
   }

  
   //_____________________________________________________________________
   // gibt die Laenge des Chromosoms zurck	
   public int length ()
   {      
      return chrom.length;
   }
 

  

   // in dieser Methode wird anstelle von einem Crossover im herkmmlichen
   // Sinn nur mehrmals eine Mutation durchgefhrt.
   // dadurch wird gewhrleistet, da in jedem Chromosom ein Indexwert nur einmal
   // vorkommt
   void crossover()
   {
      int i;
  	
      System.out.println("Crossover bei C2");	
      for (i=0; i<chrom.length/4; i++)
      	mutiere();	
      
   }


  /**
   ** This method performs the GA mutation operation.
   **
   ** @param 
   ** @return void
   ** @exception
   */
   void mutiere()
   {
      int i, j,k;
      int temp;

      
      
      for (i=0; i<chrom.length/1.5; i++) {
      	if (GA.mutiere_C2(chrom.length) )
         {
          System.out.println("   Mutiere c2");
          // suche 2 Mutationspunkte
          k = GA.c_punkt(chrom.length);  
          j = GA.c_punkt(chrom.length);  
          
          // beiden Stellen vertauschen
          temp = chrom[k];
          chrom[k] = chrom[j];
          chrom[j] = temp;
       }  }
      
   }


 
  /**
   ** This accessor method returns the chromosome of this Individual
   **
   ** @param 
   ** @return A BitSet which is this Individuals chromosome
   ** @exception
   */
   public int[] chrom()
   {
      return chrom;
   }


  
/**
   ** Clean up after this Individual to help in garbage collection.
   **
   ** @param
   ** @return void
   ** @exception
   */
   protected void finalize()
   {
      chrom = null;
   }


  

}
