   package ga;

   import java.util.Vector;


   public class Population
   {
   /** The individuals Vector holds the popsize Individuals of this Pop */
      Vector individuen;
      int sum;
   
   
   // Konstruktor: legt einen Vector an	
      public Population()
      {
         individuen = new Vector();
      
      
      }
   
   
   /**
   ** Free up all memory for this population by freeing the Individuals in
   ** this Populations individuals vector.
   **
   ** @param 
   ** @return void
   ** @exception
   */
      protected void finalize()
      {
         individuen.removeAllElements();
         individuen = null;
      }
   
   
   
   // Berechnet die Summe der Fitnesswerte aller Individuen	
      public void berechne_summe()
      {
         sum = 0;
         int i;
      
         i=0;
      
      
         while (this.ausgeben(i) != null) {
            sum += this.ausgeben(i).ausgabe_fitness();
            i++;    	
         }
      
         System.out.println("Summe: " + sum);
      
      }   
   
   
   //hinzufuegen eines Individuums ans Ende der Liste
      public void hinzufuegen(Individuum neu) {
         individuen.addElement(neu);
      }
   
    //ausgabe eines Individuums an der Stelle Position
      public Individuum ausgeben(int position) {
         if (position >= (individuen.size()))
         {
            return null;}//ausnahmebehandlung!!!!!!!
         else        
            return (Individuum) individuen.elementAt(position);
      }
   
   
   // Selektiert ein Individuum aus der Population.
   // Zugrundeliegender Algorthmus ist Standard Roulette-Wheel-Selektion
      public Individuum selektiere()
      {
         int i;
      // Zufallssumme
         double r = GA.next_double() * sum;
      // Teilsumme
         double partsum = 0.0;
      
         i=0;
         while ((this.ausgeben(i) != null) && (partsum < r)) {
            partsum += this.ausgeben(i).ausgabe_fitness();
            i++;
         }
      
         if (i == 0)
         	i=1;
         	
         System.out.println("Selektiert: " + (i-1));
      
         return this.ausgeben(i-1);
      
      }
   
    // Anzahl der Individuen
    public int size(){

	return individuen.size();      	
    }   
   
}   


