

// hauptfenster  



   package oop; 

   import grunddaten.*;
   import ga.*; 
   import java.awt.FileDialog; 
   import java.util.BitSet; 



   public class hauptfenster extends javax.swing.JFrame { 
   
      boolean cond = false;//ist bereits eine anzeige der simulation durchgefuehrt
      private java.awt.List nummer_list = new java.awt.List ();
   
     // Fenster
      welt_fenster mywelt_fenster = new welt_fenster (this, false);
      agenten_fenster myagenten_fenster = new agenten_fenster (this, false);
      objekte_fenster myobjekte_fenster = new objekte_fenster (this, false);
      aufstellungs_dialog myaufstellungs_dialog = new aufstellungs_dialog(this,false);
      details mydetails = new details (this, false);
   
     // Grunddaten      
      public Welt myWelt = new Welt(); 
      public Agentenliste myAgentenliste = new Agentenliste();
      public Objektliste myObjektliste = new Objektliste();
   
      public int aufstellungsindex = 0;
      WeltCanvas zeichenflaeche = new WeltCanvas(1,1);
   
      BitSet sperrflaeche_w;  // Flaechen, welche entweder Sperrflaechen sind
   
      int chromlaenge_C1 = -1; // Chromosomenlaenge des ersten Chromosoms  
   
      boolean simulation = false; // ist bereits eine Simulation druchgefhrt worden
   
          // Anzahl aller Bewegungen, die ein Agent bei einer Simulation macht.
      static int agentenbewegungen = -1; 
   
   
      public Aufstellungsliste myAufstellungsliste = new Aufstellungsliste();
   
   ///////////////////////////////////////////////////7
   //beginn der methoden fuer das dialogfeld details
   ////////////////////////////////////////////////////
   
   
      public int wie_gross_nummer_list(){
      
         return nummer_list.getItemCount();
      }
   
   
   
      public String einlesen_in_dialog_choice(int i){
      
         String leer = "      ";
         String nr = "Nr.:   ";
         String name = "Objektname: ";
      
      
         String objekt_nummer = nummer_list.getItem(i);
         String objekt_name = name_list.getItem(i);
         String zusammen = nr+objekt_nummer+leer+name+objekt_name ;
         return zusammen; 
      
      }
   
   
   ////////////////////////////////////////////////////
   //ende der methoden fuer das dialogfeld details
   ////////////////////////////////////////////////////
   
   
   
      // Methode, die das Zeichnen einer Welt auf der Zeichenflaeche im Hauptfenster veranlasst
      public void zeichnen(Welt temp_welt) {
         if (temp_welt != null) {
         
            Point3d temppoint = temp_welt.ausgabe_groesse();
         
            zeichenflaeche.setSize(temppoint.ausgabe_x()*temp_welt.ausgabe_raster_k(),
               temppoint.ausgabe_y()*temp_welt.ausgabe_raster_k());
         
            zeichenflaeche.zeichnen(temp_welt);
         }
      }
   
        // Methode, um eine Objekt-Aufstellung in die awt-Listen hinzuzufuegen
      public void aufst2awtlisten(Objektaufstellung tagesliste) {
      
         int id;
         Objekt obj;
         String name;
         String position;
         String groesse;
         String ausr;
         Status status;
      
        // Loesche alle Eintraege der grafischen Listen und Textfelder
         nummer_list.removeAll();
         nummer_textf.setText("");
         name_list.removeAll();
         name_textf.setText("");
         position_list.removeAll();
         position_textf.setText("");
         ausdehnung_list.removeAll();
         ausdehnung_textf.setText("");
         ausrichtung_list.removeAll();
         ausrichtung_choice.select("auto");
      
        // Fuege alle Eintraege der Aufstellung den grafischen Listen hinzu                     
         int i = 0;
         while ((tagesliste != null) && (tagesliste.ausgabe_eintrag(i) != null)) {
         
                // Daten aus Aufstellung in Strings einlesen
            id = tagesliste.ausgabe_eintrag(i).ausgabe_id();
            obj = myObjektliste.objekt_ausgeben_id(id);
            name = obj.ausgabe_name();
            groesse = obj.ausgabe_groesse().ausgabe_string();
         
            status = tagesliste.ausgabe_eintrag(i).ausgabe_status();
         
            if ((status != null) &&
            (status.ausgabe_position().ausgabe_x() != -1) &&
            (status.ausgabe_position().ausgabe_y() != -1) &&
            (status.ausgabe_position().ausgabe_z() != -1))
            {
               position = status.ausgabe_position().ausgabe_string();
               ausr = (new Character(status.ausgabe_ausrichtung())).toString();
            }
            else {
               position = "auto";
               ausr = "auto";
            }
         
                // Daten in awt.Listen einfuegen
            nummer_list.add(Integer.toString(id));
            name_list.add(name);
            position_list.add(position);
            ausdehnung_list.add(groesse);
            ausrichtung_list.add(ausr);
         
            i++;
         }
      
      }
   
        // Methode, um Objekte der Aufstellung hinzuzufuegen
      public void obj2aufst_hinzufuegen(Objektliste hinzufuegenliste) {
      
        // Lege Hilfsobjekt tagesliste an
         Objektaufstellung tagesliste;
         tagesliste = myAufstellungsliste.ausgabe_aufstellung(aufstellungsindex);
      
         // Fuege alle noch nicht enthaltenen Objekte der aktuellen Aufstellung hinzu
      
         int id;
         String name;
         String groesse;
         ObjektStatus obj_status; 
      
         int i = 0;
         while ((hinzufuegenliste != null) && (hinzufuegenliste.objekt_ausgeben(i) != null)) {
         
            if (!(tagesliste.enthaelt_objekt(hinzufuegenliste.objekt_ausgeben(i).ausgabe_id()))) {
            
               id = hinzufuegenliste.objekt_ausgeben(i).ausgabe_id();
               name = hinzufuegenliste.objekt_ausgeben(i).ausgabe_name();
               groesse = hinzufuegenliste.objekt_ausgeben(i).ausgabe_groesse().ausgabe_string();
               obj_status = new ObjektStatus(id, new Status());
            
                // Objekt in aktuelle Aufstellung einfuegen
               tagesliste.hinzufuegen_eintrag(obj_status);
            
                // Testausgabe:
               System.out.println("Hinzugefuegt: " + myObjektliste.objekt_ausgeben_id(id).ausgabe_id());
            
                // ... und in grafische Aufstellungslisten einfuegen
               nummer_list.add(Integer.toString(id));
               name_list.add(name);
               position_list.add("auto");
               ausdehnung_list.add(groesse);
               ausrichtung_list.add("auto");
            }
            i++;
         }
      
        // Loesche die Objekte, die nicht mehr gebraucht werden aus der aktuellen Aufstellung
      
        // Lege Hilfsobjekt Komplement(hinzufuegenliste) an
      
         Objektliste entfernenliste = hinzufuegenliste.komplement(myObjektliste);
      
         i = 0;
         while ((entfernenliste != null) && (entfernenliste.objekt_ausgeben(i) != null)) {
         
            if (tagesliste.enthaelt_objekt(entfernenliste.objekt_ausgeben(i).ausgabe_id())) {
            
               id = entfernenliste.objekt_ausgeben(i).ausgabe_id();
            
                // Objekt aus aktueller Aufstellung loeschen
               tagesliste.loesche_eintrag_id(id);
            
                //Test:
               System.out.println("Geloescht: " + myObjektliste.objekt_ausgeben_id(id).ausgabe_id());
            
                // ... und aus grafischer Aufstellungsliste loeschen
               for (int j = 0; j < nummer_list.getItemCount(); j++) {
                  if (id == Integer.parseInt(nummer_list.getItem(j))) {
                  
                     nummer_list.remove(j);
                     name_list.remove(j);
                     position_list.remove(j);
                     ausdehnung_list.remove(j);
                     ausrichtung_list.remove(j);
                  }
               }        
            }
            i++;
         }
      
        //Test:
         i = 0;
         while((tagesliste != null) && (tagesliste.ausgabe_eintrag(i) != null)) {
            System.out.println("Aufgestellt: " + tagesliste.ausgabe_eintrag(i).ausgabe_id());
            i++;
         }
        // Und schliesslich: Zeichne Welt neu
         zeichenflaeche.zeichnen(myWelt, myObjektliste, tagesliste);
      
      }
   
   
   
   //__________________________________________________________________________ 
   // Initialisiert die Sperrflaechen (besetzte Stellen = 1)
   // Eingaenge sind auch Sperrflaechen !!
   // Ausgaenge nicht! 
      public void init_sperrflaeche_welt () { 
         int dim_x; 
         int dim_y; 
         Point3d temp; 
         int k; 
         int i, j, n; 
         int lo_x, lo_y, ru_x, ru_y; 
      
      
        // alle notwendigen Klassen muessen existieren! 
         if (myWelt != null ) { 
         
         
            temp = myWelt.ausgabe_groesse();          
            k = myWelt.ausgabe_raster_k(); 
            dim_x = temp.ausgabe_x() * k; 
            dim_y = temp.ausgabe_y() * k; 
         
            sperrflaeche_w = new BitSet(dim_x*dim_y); //Welt  
         
            // Sperrflaechen in den BitString sperrflaeche_w schreiben 
            for (i=0; myWelt.ausgabe_sperrflaechen_lo_x(i) != -1; i++) { 
               lo_x = myWelt.ausgabe_sperrflaechen_lo_x(i); 
               lo_y = myWelt.ausgabe_sperrflaechen_lo_y(i); 
               ru_x = myWelt.ausgabe_sperrflaechen_ru_x(i); 
               ru_y = myWelt.ausgabe_sperrflaechen_ru_y(i); 
            
                        // Zeilen durchlaufen 
               for(; lo_y < ru_y; lo_y ++) 
                                // Spalten durchlaufen 
                  for(j=lo_x; j < ru_x; j++) 
                                        // Punkt als Sperrflaeche kennzeichen 
                     sperrflaeche_w.set(lo_y*dim_x + j); 
            
            }  
         
            // Eingaenge in den BitString sperrflaeche_w schreiben 
            for (i=0; myWelt.ausgabe_eingaenge_lo_x(i) != -1; i++) { 
               lo_x = myWelt.ausgabe_eingaenge_lo_x(i); 
               lo_y = myWelt.ausgabe_eingaenge_lo_y(i); 
               ru_x = myWelt.ausgabe_eingaenge_ru_x(i); 
               ru_y = myWelt.ausgabe_eingaenge_ru_y(i); 
            
                        // Zeilen durchlaufen 
               for(; lo_y < ru_y; lo_y ++) 
                                // Spalten durchlaufen 
                  for(j=lo_x; j < ru_x; j++) 
                                        // Punkt als Sperrflaeche kennzeichen 
                     sperrflaeche_w.set(lo_y*dim_x + j); 
            
            }         
         
         
         
         /*
               // testen ob alles richtig erzeugt wurde 
            int te; 
            for (i=0; i < dim_y; i++) 
            {
               for (te=0; te< dim_x; te++) 
                  if (sperrflaeche_w.get(dim_x*i + te)) 
                     System.out.print("1"); 
                  else System.out.print("0"); 
            
               System.out.println(" "); }     */              
         
         }                
         else System.out.println 
               ("hauptfenster: (init_sperrflaeche_welt) Es sind noch nicht alle ntigen Grunddaten eingegeben!"); 
      } 
   
   
   //__________________________________________________________________________ 
   // berprft ob ein bestimmter Punkt innerhalb der Welt ist 
      public boolean ist_enthalten (Point3d punkt) { 
         int x = punkt.ausgabe_x(); 
         int y = punkt.ausgabe_y(); 
         int k; 
      
         if (myWelt == null) {  
            System.out.println 
               ("hauptfenster: (ist_enthalten) Es sind noch nicht alle ntigen Grunddaten eingegeben!"); 
            return false; 
         } 
      
         k = myWelt.ausgabe_raster_k();    
        // zu weit links oder oben 
         if (x < 0 || y < 0) 
            return false; 
      
        // zu weit rechts oder unten 
         if (x >= myWelt.ausgabe_groesse().ausgabe_x()*k || 
         y >= myWelt.ausgabe_groesse().ausgabe_y()*k) 
            return false; 
      
         return true; 
      } 
   
   //________________________________________________
      public BitSet ausgabe_sperrflaeche_w () {
         return sperrflaeche_w;
      }
   
   
   
   //__________________________________________________________________________ 
   
   
   /////////////////////////////////////////////////////////////////////////// 
   // Beginn Oberflaeche 
   /////////////////////////////////////////////////////////////////////////// 
   
   
   /** Initializes the Form */
      public hauptfenster() {
      
        // Anlegen der (leeren) Aufstellungsliste mit 30 Einraegen
         for (int i = 0; i < 30; i++)
            myAufstellungsliste.hinzufuegen_aufstellung(new Objektaufstellung());
         initComponents ();
         pack ();
      }
   
   /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
      private void initComponents () {//GEN-BEGIN:initComponents
         setTitle ("Optimierte Objektpositionierung 0.2");
         addWindowListener (
               new java.awt.event.WindowAdapter () {
                  public void windowClosing (java.awt.event.WindowEvent evt) {
                     exitForm (evt);
                  }
               }
            );
         getContentPane ().setLayout (new java.awt.BorderLayout ());
      
         Menue = new javax.swing.JMenuBar ();
         jMenu1 = new javax.swing.JMenu ();
         jMenu1.setText ("Datei");
         jMenu1.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     datei_evt (evt);
                  }
               }
            );
         jMenuItem1 = new javax.swing.JMenuItem ();
         jMenuItem1.setText ("Neu");
         jMenuItem1.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     datei_neu_evt (evt);
                  }
               }
            );
         jMenu1.add(jMenuItem1);
      
         oeffnen = new javax.swing.JMenuItem ();
         oeffnen.setText ("ffnen");
         oeffnen.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     datei_oeffnen_evt (evt);
                  }
               }
            );
         jMenu1.add(oeffnen);
      
         jMenuItem3 = new javax.swing.JMenuItem ();
         jMenuItem3.setText ("Speichern");
         jMenuItem3.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     datei_speichern_evt (evt);
                  }
               }
            );
         jMenu1.add(jMenuItem3);
      
         jMenuItem4 = new javax.swing.JMenuItem ();
         jMenuItem4.setActionCommand ("Speichern unter ...");
         jMenuItem4.setText ("Speichern unter ...");
         jMenuItem4.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     datei_speichern_unter_evt (evt);
                  }
               }
            );
         jMenu1.add(jMenuItem4);
      
         jMenuItem5 = new javax.swing.JMenuItem ();
         jMenuItem5.setText ("Beenden");
         jMenuItem5.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     datei_beenden_evt (evt);
                  }
               }
            );
         jMenu1.add(jMenuItem5);
      
         Menue.add(jMenu1);
      
         jMenu2 = new javax.swing.JMenu ();
         jMenu2.setText ("Grunddaten");
         jMenu2.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     grunddaten_evt (evt);
                  }
               }
            );
         jMenu3 = new javax.swing.JMenu ();
         jMenu3.setText ("Welt");
         jMenu3.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     welt_fenster_evt (evt);
                  }
               }
            );
         jMenuItem6 = new javax.swing.JMenuItem ();
         jMenuItem6.setText ("Bearbeiten");
         jMenuItem6.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     welt_fenster_bearbeiten_evt (evt);
                  }
               }
            );
         jMenu3.add(jMenuItem6);
      
         jMenuItem7 = new javax.swing.JMenuItem ();
         jMenuItem7.setText ("Laden");
         jMenuItem7.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     welt_fenster_laden_evt (evt);
                  }
               }
            );
         jMenu3.add(jMenuItem7);
      
         jMenu2.add(jMenu3);
      
         jMenu4 = new javax.swing.JMenu ();
         jMenu4.setText ("Objekte");
         jMenu4.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     objekte_evt (evt);
                  }
               }
            );
         jMenuItem13 = new javax.swing.JMenuItem ();
         jMenuItem13.setText ("Laden");
         jMenuItem13.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     objekte_laden_evt (evt);
                  }
               }
            );
         jMenu4.add(jMenuItem13);
      
         jMenuItem16 = new javax.swing.JMenuItem ();
         jMenuItem16.setText ("Bearbeiten");
         jMenuItem16.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     objekte_bearbeiten_evt (evt);
                  }
               }
            );
         jMenu4.add(jMenuItem16);
      
         jMenu2.add(jMenu4);
      
         jMenu5 = new javax.swing.JMenu ();
         jMenu5.setText ("Agenten");
         jMenu5.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     agenten_evt (evt);
                  }
               }
            );
         jMenuItem15 = new javax.swing.JMenuItem ();
         jMenuItem15.setText ("Laden");
         jMenuItem15.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     agenten_laden (evt);
                  }
               }
            );
         jMenu5.add(jMenuItem15);
      
         jMenuItem17 = new javax.swing.JMenuItem ();
         jMenuItem17.setText ("Bearbeiten");
         jMenuItem17.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     agenten_bearbeiten_evt (evt);
                  }
               }
            );
         jMenu5.add(jMenuItem17);
      
         jMenu2.add(jMenu5);
      
         Menue.add(jMenu2);
      
         jMenu6 = new javax.swing.JMenu ();
         jMenu6.setText ("Start");
         jMenu6.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     start_evt (evt);
                  }
               }
            );
         jMenuItem18 = new javax.swing.JMenuItem ();
         jMenuItem18.setText ("Simulation");
         jMenuItem18.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     start_simulation_evt (evt);
                  }
               }
            );
         jMenu6.add(jMenuItem18);
      
         jMenuItem21 = new javax.swing.JMenuItem ();
         jMenuItem21.setText ("Optimierungszyklus");
         jMenuItem21.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     start_optimierungszyklus_evt (evt);
                  }
               }
            );
         jMenu6.add(jMenuItem21);
      
         Menue.add(jMenu6);
      
         jMenu7 = new javax.swing.JMenu ();
         jMenu7.setText ("Optionen");
         jMenu7.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     optionen_evt (evt);
                  }
               }
            );
         jMenuItem8 = new javax.swing.JMenuItem ();
         jMenuItem8.setText ("Objektaufstellung(en) laden");
         jMenuItem8.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     objektaufstellung_laden_evt (evt);
                  }
               }
            );
         jMenu7.add(jMenuItem8);
      
         jMenuItem25 = new javax.swing.JMenuItem ();
         jMenuItem25.setText ("Einstellungen");
         jMenuItem25.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     einstellungen_evt (evt);
                  }
               }
            );
         jMenuItem25.addMouseListener (
               new java.awt.event.MouseAdapter () {
                  public void mouseClicked (java.awt.event.MouseEvent evt) {
                     none (evt);
                  }
               }
            );
         jMenu7.add(jMenuItem25);
      
         Menue.add(jMenu7);
      
         jMenu8 = new javax.swing.JMenu ();
         jMenu8.setText ("Hilfe");
         jMenu8.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     hilfe_evt (evt);
                  }
               }
            );
         jMenuItem20 = new javax.swing.JMenuItem ();
         jMenuItem20.setText ("About");
         jMenuItem20.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     jMenuItem20ActionPerformed (evt);
                  }
               }
            );
         jMenu8.add(jMenuItem20);
      
         Menue.add(jMenu8);
      
      
         setJMenuBar(Menue);
      
      
      
         // beginn toolbar von Markus
      
         jPanel3 = new javax.swing.JPanel ();
         jPanel3.setLayout (new java.awt.BorderLayout ());
      
         jPanel1 = new javax.swing.JPanel ();
         jPanel1.setPreferredSize (new java.awt.Dimension(8, 8));
         jPanel1.setMinimumSize (new java.awt.Dimension(8, 8));
         jPanel1.setMaximumSize (new java.awt.Dimension(8, 8));
         jPanel1.setLayout (new com.netbeans.developer.awt.AbsoluteLayout ());
      
         jPanel3.add (jPanel1, "North");
      
         jPanel2 = new javax.swing.JPanel ();
         jPanel2.setPreferredSize (new java.awt.Dimension(8, 8));
         jPanel2.setMinimumSize (new java.awt.Dimension(8, 8));
         jPanel2.setMaximumSize (new java.awt.Dimension(8, 8));
         jPanel2.setLayout (new com.netbeans.developer.awt.AbsoluteLayout ());
      
         jPanel3.add (jPanel2, "South");
      
         jToolBar1 = new javax.swing.JToolBar ();
         jToolBar1.setLayout (new javax.swing.BoxLayout (jToolBar1, 0));
      
         zurueck = new javax.swing.JButton ();
         zurueck.setIcon (new javax.swing.ImageIcon ("oop/pic/zurueck.gif"));
         zurueck.setToolTipText ("vorherige Aufstellung");
         zurueck.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     zurueckActionPerformed (evt);
                  }
               }
            );
         jToolBar1.add (zurueck);
      
         seite = new javax.swing.JLabel ();
         seite.setPreferredSize (new java.awt.Dimension(35, 17));
         seite.setMinimumSize (new java.awt.Dimension(35, 17));
         seite.setText ((aufstellungsindex+1) + "/30");
         seite.setHorizontalAlignment (javax.swing.SwingConstants.CENTER);
         seite.setMaximumSize (new java.awt.Dimension(35, 17));
         jToolBar1.add (seite);
      
         vor = new javax.swing.JButton ();
         vor.setIcon (new javax.swing.ImageIcon ("oop/pic/vor.gif"));
         vor.setToolTipText ("nchste Aufstellung");
         vor.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     vorActionPerformed (evt);
                  }
               }
            );
         jToolBar1.add (vor);
      
         jSeparator2 = new javax.swing.JSeparator ();
         jSeparator2.setOrientation (javax.swing.SwingConstants.VERTICAL);
         jToolBar1.add (jSeparator2);
      
         aufstellung_simulieren = new javax.swing.JButton ();
         aufstellung_simulieren.setIcon (new javax.swing.ImageIcon ("oop/pic/play.gif"));
         aufstellung_simulieren.setToolTipText ("Anzeige der Simulation");
         aufstellung_simulieren.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     aufstellung_simulierenActionPerformed (evt);
                  }
               }
            );
         jToolBar1.add (aufstellung_simulieren);
      
         jSeparator1 = new javax.swing.JSeparator ();
         jSeparator1.setOrientation (javax.swing.SwingConstants.VERTICAL);
         jToolBar1.add (jSeparator1);
      
         details = new javax.swing.JButton ();
         details.setText ("Details");
         details.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     detailsActionPerformed (evt);
                  }
               }
            );
         jToolBar1.add (details);
      
         jPanel3.add (jToolBar1, "West");
      
         getContentPane().add (jPanel3, "North");
      
        // end toolbar 
        //______________
      
      
         objektaufstellung = new javax.swing.JPanel ();
         objektaufstellung.setBorder (new javax.swing.border.TitledBorder (
            new javax.swing.border.EtchedBorder (), "Objektaufstellung"));
         objektaufstellung.setLayout (new java.awt.BorderLayout ());
      
         liste = new javax.swing.JPanel ();
         liste.setPreferredSize (new java.awt.Dimension(400, 200));
         liste.setMinimumSize (new java.awt.Dimension(300, 200));
         liste.addComponentListener (
               new java.awt.event.ComponentAdapter () {
                  public void componentMoved (java.awt.event.ComponentEvent evt) {
                     jPanel1ComponentMoved (evt);
                  }
               }
            );
         liste.setLayout (new javax.swing.BoxLayout (liste, 0));
      
         nummer_p = new javax.swing.JPanel ();
         nummer_p.setPreferredSize (new java.awt.Dimension(40, 70));
         nummer_p.setMinimumSize (new java.awt.Dimension(40, 70));
         nummer_p.setMaximumSize (new java.awt.Dimension(40, 32767));
         nummer_p.setLayout (new java.awt.BorderLayout ());
      
         nummer_list = new java.awt.List ();
         nummer_list.addItemListener (
               new java.awt.event.ItemListener() {
                  public void itemStateChanged (java.awt.event.ItemEvent evt) {
                     nummer_listItemEvent (evt);
                  }
               }
            );
         nummer_p.add (nummer_list, "Center");
      
         liste.add (nummer_p);
      
         name_p = new javax.swing.JPanel ();
         name_p.setPreferredSize (new java.awt.Dimension(200, 72));
         name_p.setMinimumSize (new java.awt.Dimension(200, 70));
         name_p.setMaximumSize (new java.awt.Dimension(200, 32767));
         name_p.setLayout (new java.awt.BorderLayout ());
      
         name_list = new java.awt.List ();
         name_list.addItemListener (
               new java.awt.event.ItemListener() {
                  public void itemStateChanged (java.awt.event.ItemEvent evt) {
                     name_listItemEvent (evt);
                  }
               }
            );
         name_p.add (name_list, "Center");
      
         liste.add (name_p);
      
         position_p = new javax.swing.JPanel ();
         position_p.setPreferredSize (new java.awt.Dimension(100, 72));
         position_p.setMinimumSize (new java.awt.Dimension(100, 70));
         position_p.setMaximumSize (new java.awt.Dimension(100, 32767));
         position_p.setLayout (new java.awt.BorderLayout ());
      
         position_list = new java.awt.List ();
         position_list.addItemListener (
               new java.awt.event.ItemListener() {
                  public void itemStateChanged (java.awt.event.ItemEvent evt) {
                     position_listItemEvent (evt);
                  }
               }
            );
         position_p.add (position_list, "Center");
      
         liste.add (position_p);
      
         ausdehnung_p = new javax.swing.JPanel ();
         ausdehnung_p.setPreferredSize (new java.awt.Dimension(100, 72));
         ausdehnung_p.setMinimumSize (new java.awt.Dimension(100, 70));
         ausdehnung_p.setMaximumSize (new java.awt.Dimension(100, 32767));
         ausdehnung_p.setLayout (new java.awt.BorderLayout ());
      
         ausdehnung_list = new java.awt.List ();
         ausdehnung_list.addItemListener (
               new java.awt.event.ItemListener() {
                  public void itemStateChanged (java.awt.event.ItemEvent evt) {
                     ausdehnung_listItemEvent (evt);
                  }
               }
            );
         ausdehnung_p.add (ausdehnung_list, "Center");
      
         liste.add (ausdehnung_p);
      
         ausrichtung_p = new javax.swing.JPanel ();
         ausrichtung_p.setPreferredSize (new java.awt.Dimension(50, 70));
         ausrichtung_p.setMinimumSize (new java.awt.Dimension(50, 70));
         ausrichtung_p.setMaximumSize (new java.awt.Dimension(50, 32767));
         ausrichtung_p.setLayout (new java.awt.BorderLayout ());
      
         ausrichtung_list = new java.awt.List ();
         ausrichtung_list.addItemListener (
               new java.awt.event.ItemListener() {
                  public void itemStateChanged (java.awt.event.ItemEvent evt) {
                     ausrichtung_listItemEvent (evt);
                  }
               }
            );
         ausrichtung_p.add (ausrichtung_list, "Center");
      
         liste.add (ausrichtung_p);
      
         objbuttons_p = new javax.swing.JPanel ();
         objbuttons_p.setPreferredSize (new java.awt.Dimension(50, 72));
         objbuttons_p.setMinimumSize (new java.awt.Dimension(50, 70));
         objbuttons_p.setMaximumSize (new java.awt.Dimension(50, 32767));
         objbuttons_p.setLayout (new java.awt.FlowLayout ());
      
         allehinzufuegen = new javax.swing.JButton ();
         allehinzufuegen.setIcon(new javax.swing.ImageIcon ("oop/pic/alle_obj.gif"));
         allehinzufuegen.setBorder(null);
         allehinzufuegen.setToolTipText("Alle Objekte in Aufstellung verwenden");
         allehinzufuegen.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     allehinzufuegenActionPerformed (evt);
                  }
               }
            );
      
         hinzufuegen = new javax.swing.JButton ();
         hinzufuegen.setIcon(new javax.swing.ImageIcon ("oop/pic/aufst_dialog.gif"));
         hinzufuegen.setBorder(null);
         hinzufuegen.setToolTipText("Objekte auswaehlen, die aufgestellt werden");
         hinzufuegen.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     hinzufuegenActionPerformed (evt);
                  }
               }
            );
      
         objbuttons_p.add (allehinzufuegen);
         objbuttons_p.add (hinzufuegen);
      
         liste.add (objbuttons_p);
      
         objektaufstellung.add (liste, "Center");
      
         eingabe = new javax.swing.JPanel ();
         eingabe.setLayout (new java.awt.BorderLayout ());
      
         textfelder = new javax.swing.JPanel ();
         textfelder.setLayout (new javax.swing.BoxLayout (textfelder, 0));
      
         nummer_textf = new javax.swing.JTextField ();
         nummer_textf.setEnabled (false);
         nummer_textf.setPreferredSize (new java.awt.Dimension(40, 21));
         nummer_textf.setEditable (false);
         nummer_textf.setMaximumSize (new java.awt.Dimension(40, 100));
         nummer_textf.setText ("n");
         nummer_textf.setMinimumSize (new java.awt.Dimension(40, 21));
         nummer_textf.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     nummer_textfActionPerformed (evt);
                  }
               }
            );
         textfelder.add (nummer_textf);
      
         name_textf = new javax.swing.JTextField ();
         name_textf.setEnabled(false);
         name_textf.setEditable(false);
         name_textf.setPreferredSize (new java.awt.Dimension(200, 21));
         name_textf.setMaximumSize (new java.awt.Dimension(200, 100));
         name_textf.setText ("");
         name_textf.setMinimumSize (new java.awt.Dimension(200, 21));
         name_textf.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     name_textfActionPerformed (evt);
                  }
               }
            );
         textfelder.add (name_textf);
      
         position_textf = new javax.swing.JTextField ();
         position_textf.setPreferredSize (new java.awt.Dimension(100, 21));
         position_textf.setMaximumSize (new java.awt.Dimension(100, 100));
         position_textf.setText ("");
         position_textf.setMinimumSize (new java.awt.Dimension(100, 21));
         position_textf.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     position_textfActionPerformed (evt);
                  }
               }
            );
         textfelder.add (position_textf);
      
         ausdehnung_textf = new javax.swing.JTextField ();
         ausdehnung_textf.setEnabled(false);
         ausdehnung_textf.setEditable(false);
         ausdehnung_textf.setPreferredSize (new java.awt.Dimension(100, 21));
         ausdehnung_textf.setMaximumSize (new java.awt.Dimension(100, 100));
         ausdehnung_textf.setText ("");
         ausdehnung_textf.setMinimumSize (new java.awt.Dimension(100, 21));
         ausdehnung_textf.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     ausdehnung_textfActionPerformed (evt);
                  }
               }
            );
         textfelder.add (ausdehnung_textf);
      
         ausrichtung_choice = new java.awt.Choice ();
         ausrichtung_choice.add ("auto");
         ausrichtung_choice.add ("N");
         ausrichtung_choice.add ("O");
         ausrichtung_choice.add ("S");
         ausrichtung_choice.add ("W");
      
         textfelder.add (ausrichtung_choice);
      
         uebernehmen = new javax.swing.JButton ();
         uebernehmen.setIcon(new javax.swing.ImageIcon ("oop/pic/aendern.gif"));
         uebernehmen.setText("aendern");
         uebernehmen.setBorder(null);
         uebernehmen.setToolTipText("aendern von Pos. und Ausr.");
         uebernehmen.addActionListener (
               new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                     uebernehmenActionPerformed (evt);
                  }
               }
            );
         textfelder.add (uebernehmen);
      
         eingabe.add (textfelder, "Center");
      
         beschriftung = new javax.swing.JPanel ();
         beschriftung.setLayout (new javax.swing.BoxLayout (beschriftung, 0));
      
         nummer_beschr = new javax.swing.JLabel ();
         nummer_beschr.setPreferredSize (new java.awt.Dimension(40, 21));
         nummer_beschr.setMinimumSize (new java.awt.Dimension(40, 21));
         nummer_beschr.setVerticalAlignment (javax.swing.SwingConstants.BOTTOM);
         nummer_beschr.setText ("Nr.");
         nummer_beschr.setHorizontalTextPosition (javax.swing.SwingConstants.CENTER);
         nummer_beschr.setHorizontalAlignment (javax.swing.SwingConstants.CENTER);
         nummer_beschr.setMaximumSize (new java.awt.Dimension(40, 100));
         beschriftung.add (nummer_beschr);
      
         name_beschr = new javax.swing.JLabel ();
         name_beschr.setPreferredSize (new java.awt.Dimension(200, 21));
         name_beschr.setMinimumSize (new java.awt.Dimension(200, 21));
         name_beschr.setVerticalAlignment (javax.swing.SwingConstants.BOTTOM);
         name_beschr.setText ("Name");
         name_beschr.setHorizontalTextPosition (javax.swing.SwingConstants.CENTER);
         name_beschr.setHorizontalAlignment (javax.swing.SwingConstants.CENTER);
         name_beschr.setMaximumSize (new java.awt.Dimension(200, 21));
         beschriftung.add (name_beschr);
      
         position_beschr = new javax.swing.JLabel ();
         position_beschr.setPreferredSize (new java.awt.Dimension(100, 21));
         position_beschr.setMinimumSize (new java.awt.Dimension(100, 21));
         position_beschr.setVerticalAlignment (javax.swing.SwingConstants.BOTTOM);
         position_beschr.setText ("Pos.");
         position_beschr.setHorizontalTextPosition (javax.swing.SwingConstants.CENTER);
         position_beschr.setHorizontalAlignment (javax.swing.SwingConstants.CENTER);
         position_beschr.setMaximumSize (new java.awt.Dimension(100, 100));
         beschriftung.add (position_beschr);
      
         ausdehnung_beschr = new javax.swing.JLabel ();
         ausdehnung_beschr.setPreferredSize (new java.awt.Dimension(100, 21));
         ausdehnung_beschr.setMinimumSize (new java.awt.Dimension(100, 21));
         ausdehnung_beschr.setVerticalAlignment (javax.swing.SwingConstants.BOTTOM);
         ausdehnung_beschr.setText ("Dim.");
         ausdehnung_beschr.setHorizontalTextPosition (javax.swing.SwingConstants.CENTER);
         ausdehnung_beschr.setHorizontalAlignment (javax.swing.SwingConstants.CENTER);
         ausdehnung_beschr.setMaximumSize (new java.awt.Dimension(100, 100));
         beschriftung.add (ausdehnung_beschr);
      
         ausrichtung_beschr = new javax.swing.JLabel ();
         ausrichtung_beschr.setPreferredSize (new java.awt.Dimension(50, 21));
         ausrichtung_beschr.setMinimumSize (new java.awt.Dimension(50, 21));
         ausrichtung_beschr.setVerticalAlignment (javax.swing.SwingConstants.BOTTOM);
         ausrichtung_beschr.setText ("Ausr.");
         ausrichtung_beschr.setHorizontalTextPosition (javax.swing.SwingConstants.CENTER);
         ausrichtung_beschr.setHorizontalAlignment (javax.swing.SwingConstants.CENTER);
         ausrichtung_beschr.setMaximumSize (new java.awt.Dimension(50, 100));
         beschriftung.add (ausrichtung_beschr);
      
         eingabe.add (beschriftung, "North");
      
         platzhalter = new javax.swing.JPanel ();
         platzhalter.setPreferredSize (new java.awt.Dimension(5, 5));
         platzhalter.setMinimumSize (new java.awt.Dimension(5, 5));
         platzhalter.setMaximumSize (new java.awt.Dimension(5, 5));
         platzhalter.setLayout (new java.awt.FlowLayout ());
      
         eingabe.add (platzhalter, "South");
      
         objektaufstellung.add (eingabe, "North");
      
         getContentPane ().add (objektaufstellung, "West");
      
         welt_fenster = new javax.swing.JPanel ();
         welt_fenster.setPreferredSize (new java.awt.Dimension(120,120));
         welt_fenster.setBorder (new javax.swing.border.TitledBorder (
            new javax.swing.border.EtchedBorder (), "Welt"));
         welt_fenster.setLayout (new java.awt.BorderLayout ());
      
         java.awt.ScrollPane myscrollpane = new java.awt.ScrollPane();
      
         welt_fenster.add("Center",myscrollpane);
      
         myscrollpane.add(zeichenflaeche);
         /*
         javax.swing.JPanel panelS = new javax.swing.JPanel();
      
         javax.swing.JButton zeichne = new javax.swing.JButton("Zeichne");
         zeichne.addActionListener(
               new java.awt.event.ActionListener()
               {
                  public void actionPerformed(java.awt.event.ActionEvent evt)
                  {
                     zeichneActionPerformed(evt);
                  }
               });
         panelS.add(zeichne);  
         
         welt_fenster.add("South",panelS);
        */
      
         getContentPane ().add (welt_fenster, "Center");
      /*
         platzhalter_oben = new javax.swing.JPanel ();
         platzhalter_oben.setMaximumSize (new java.awt.Dimension(10, 10));
         platzhalter_oben.setLayout (new java.awt.FlowLayout ());
      
         getContentPane ().add (platzhalter_oben, "North");*/
      
      }//GEN-END:initComponents
   
      private void jMenuItem20ActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem20ActionPerformed
      // Add your handling code here:
      }//GEN-LAST:event_jMenuItem20ActionPerformed
   
      private void datei_oeffnen_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_datei_oeffnen_evt
         FileDialog fileDialog = new FileDialog (this, "ffnen...", FileDialog.LOAD);
         fileDialog.show ();
         if (fileDialog.getFile () == null)
            return;
      //fileName = fileDialog.getDirectory () + File.separator + fileDialog.getFile ();
      // Add your handling code here:
      }//GEN-LAST:event_datei_oeffnen_evt
   
      private void detailsActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_detailsActionPerformed
      
         if (cond||simulation)
         {details mydetails = new details (this,true);
            mydetails.show();}
         else
         {fehler dfd = new fehler("Es wurde noch keine Simulation durchgefhrt");}
      }//GEN-LAST:event_detailsActionPerformed
   
      private void uebernehmenActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_uebernehmenActionPerformed
      // Add your handling code here:
      
         if (nummer_list.getSelectedIndex() < 0)
            return;
      
      //Strings aus den textfeldern auslesen: 
         String pos = new String(); 
         String ausr = new String(); 
         pos = position_textf.getText(); 
         ausr = ausrichtung_choice.getSelectedItem(); 
      
         try {
         
            int id = Integer.parseInt(nummer_list.getSelectedItem());
         
                //1.  Position = "" oder "auto" und Ausrichtung = "auto"
            if ((pos.equals("") | pos.equals("auto")) && ausr.equals("auto")) {
            
                // Grafische Liste anpassen
               position_list.replaceItem("auto",nummer_list.getSelectedIndex());
               ausrichtung_list.replaceItem("auto",nummer_list.getSelectedIndex());
            
                //Aufstellungseintrag anpassen
               //anlegen einer temporaeren Objektaufstellung
               Objektaufstellung tagesliste = new Objektaufstellung();
               tagesliste = myAufstellungsliste.ausgabe_aufstellung(aufstellungsindex);
            
               tagesliste.ausgabe_eintrag_id(id).ausgabe_status().aendere_position(new Point3d());
               tagesliste.ausgabe_eintrag_id(id).ausgabe_status().aendere_ausrichtung('N');
            }
            
            //2. Position = "" oder "auto" und Ausrichtung != "auto"
            else if ((pos.equals("") | pos.equals("auto")) && (!(ausr.equals("auto")))) {
            
                //Fehler
               fehler f = new fehler("Wenn Sie bei der Positionierung <auto> eintragen,",
               "bitte waehlen Sie auch bei der Ausrichtung <auto>.");
            }
            
            //3. Ausrichtung = "auto" und Position != "auto" oder ""
            else if ((ausr.equals("auto")) && (!(pos.equals("") | pos.equals("auto")))) {
            
                //Fehler
               fehler f = new fehler("Wenn Sie bei der Ausrichtung <auto> waehlen,",
               "bitte tragen Sie auch bei der Position <auto> ein.");
            }
            
            //4. Ausrichtung != "auto" und Position != "auto" oder ""
            else {
            
               Objektaufstellung tagesliste = new Objektaufstellung();
               tagesliste = myAufstellungsliste.ausgabe_aufstellung(aufstellungsindex);
            
                //Verweis auf markiertes Objekt in der Aufstellung:
               ObjektStatus hilfsstatus = tagesliste.ausgabe_eintrag_id(id);
            
                //Markiertes Objekt aus der Aufstellung entfernen (wird unten wieder hinzugefuegt)
               tagesliste.loesche_eintrag_id(id);
            
            //umwandeln des Positions-strings in einen StringTokenizer : 
               java.util.StringTokenizer teilstrings = new java.util.StringTokenizer(pos, ",./;"); //, . ; / werden als teilstrings ueberlesen 
            
            //teilstrings in int umwandeln:  
               String str_x = (String) teilstrings.nextElement(); 
               int x = Integer.parseInt(str_x); 
               String str_y = (String) teilstrings.nextElement(); 
               int y = Integer.parseInt(str_y);     
               int z = 0;
            
            //Hilfspunkte generieren
               Point3d position = new Point3d(x,y,z);
               Point3d obj_pos_von = new Point3d(x * myWelt.ausgabe_raster_k(),
               y * myWelt.ausgabe_raster_k(),
               z);
               Point3d obj_pos_bis = new Point3d((x+myObjektliste.objekt_ausgeben_id(id).ausgabe_groesse().ausgabe_x()) * myWelt.ausgabe_raster_k(), 
               (y+myObjektliste.objekt_ausgeben_id(id).ausgabe_groesse().ausgabe_y()) * myWelt.ausgabe_raster_k(),
               z);
            
               char ausrichtung = ausr.charAt(0);
            
                // Agenten aus Sperrflaechen-Array loeschen:
               tagesliste.init_sperrflaeche(myWelt, null, this);
            
               // Passt das Objekt nicht in die Welt hinein, Fehler
               if (!((ist_enthalten(obj_pos_von)) &&
               (ist_enthalten(new Point3d((x+myObjektliste.objekt_ausgeben_id(id).ausgabe_groesse().ausgabe_x()) * myWelt.ausgabe_raster_k()-1,
               (y+myObjektliste.objekt_ausgeben_id(id).ausgabe_groesse().ausgabe_y()) * myWelt.ausgabe_raster_k()-1,
               z ))))) {
               
                //fehlermeldung (koordinaten nicht erlaubt) 
                  fehler f = new fehler("Objekt passt nicht in die Welt!", "Bitte Koordinaten korrigieren."); 
               }
               
               // Ist die Position nicht frei, Fehler
               else if (!(tagesliste.ist_frei(obj_pos_von,obj_pos_bis,myWelt,this))) {
               
                        //fehlermeldung (koordinaten nicht erlaubt) 
                  fehler f = new fehler("Position nicht mehr frei", "Bitte Koordinaten korrigieren."); 
               }
               
               else {
               
               // Alles OK:
               
               // Hilfsobjekt-Status aendern
                  hilfsstatus.ausgabe_status().aendere_position(position);
                  hilfsstatus.ausgabe_status().aendere_ausrichtung(ausrichtung);
               
               // Grafische Liste aktualisieren
                  position_list.replaceItem(x + "," + y,nummer_list.getSelectedIndex());
                  ausrichtung_list.replaceItem(ausr,nummer_list.getSelectedIndex());
               }
            
               // Dann Hilfsobjekt wieder in tagesliste einfuegen
               tagesliste.hinzufuegen_eintrag(hilfsstatus);
            
               tagesliste.init_sperrflaeche(myWelt, myAgentenliste, this);
            
               // Und schliesslich: Zeichne Welt neu
               zeichenflaeche.zeichnen(myWelt, myObjektliste, tagesliste);
            
            } 
         
         } // Ende try
         
         //fehlerbehandlung: 
            catch(NumberFormatException e) 
            { 
               fehler f = new fehler("Unerlaubte Koordinaten!","Bitte korrigieren."); 
            } 
            catch(java.util.NoSuchElementException e)  
            { 
               fehler f = new fehler("Unvollstaendige Eingabe!"); 
            
            } 
      
      
      }//GEN-LAST:event_uebernehmenActionPerformed
   
      private void allehinzufuegenActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loeschenActionPerformed
      // Add your handling code here:
         obj2aufst_hinzufuegen(myObjektliste);
         myAufstellungsliste.ausgabe_aufstellung(aufstellungsindex).
            init_sperrflaeche(myWelt, myAgentenliste, this);
      
      }
      private void hinzufuegenActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_hinzufuegenActionPerformed
      // Add your handling code here:
      
        // Generiere Objektliste aus aufgestellten Objekten:
         Objektliste aufgestellt_liste = new Objektliste();
         int id;
      
         for (int i = 0; i < nummer_list.getItemCount(); i++) {
         
            id = Integer.parseInt(nummer_list.getItem(i));
            aufgestellt_liste.objekt_hinzufuegen(myObjektliste.objekt_ausgeben_id(id));
         }
      
         myaufstellungs_dialog.listen_aktualisieren(aufgestellt_liste);
         myaufstellungs_dialog.show();
      }
   
   
   
     //____________________________________________________________
      private void aufstellung_simulierenActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
      
         cond = true;//damit wei ich, ob eine simulation durch gefuerht wurde
      
      // Simulieren einer Aufstellung
      // derzeit 300 Agentenbewegungen (jeder Agent!)           
         simuliere(myAufstellungsliste.ausgabe_aufstellung(aufstellungsindex), 300, einstellungen.anzeige);      
      
      
      
      
         // Ausgabe (nur zu Testzwecken)
         System.out.println(" ");
         System.out.println("Mitprotokollieren testen: ");
      
         Objektaufstellung myaufst = myAufstellungsliste.ausgabe_aufstellung(aufstellungsindex);
         ObjektStatus test_status = myaufst.ausgabe_eintrag(0);//dies ist der objektstatus vom objekt 0
      
         int n = 0;
         int i;
         System.out.println("Objekt =0");
         while (myaufst.ausgabe_eintrag(n) != null) { 
         
            i=0;
            while (test_status.ausgabe_guthaben(i) != null) {
               System.out.println(" Guthaben: "  
                  + test_status.ausgabe_guthaben(i).ausgabe_guthaben() + " Zeit: " 
                  + test_status.ausgabe_guthaben(i).ausgabe_zeit() + ", Agent: "
                  + test_status.ausgabe_guthaben(i).ausgabe_lnkAgent().ausgabe_id() );
            
               i++;
            }
            n++;
         
         
         }
      
        // AWt-Listen aktualisieren
         aufst2awtlisten(myAufstellungsliste.ausgabe_aufstellung(aufstellungsindex));
      
        // Und Zeichen...
         zeichenflaeche.zeichnen(myWelt, myObjektliste, myAufstellungsliste.ausgabe_aufstellung(aufstellungsindex));
      
      // Ende Ausgabe
      
      
      
      
      
      
      // Ende Markus
      
      
      
      
      
      /*// Add your handling code here:
      
         // Hier wird die Simulation im aktuellen Fenster durchgefuehrt
      
         //anlegen eines Objektaufstellung
         tagesliste = new Objektaufstellung();
      
         ObjektStatus meineintrag = new ObjektStatus();
         Status meinstatus = new Status();
      
         // Auslesen der Objektaustellungs(Liste) und hinzufuegen der Aufstellunen ins Objektaufstellung
         int nr;
         String name = new String();
         String pos = new String();
         String ausr = new String();
         Point3d position = new Point3d();
         char ausrichtung;
      
         for (int i = 0; i < nummer_list.getItemCount(); i++) {
            pos = position_list.getItem(i);
            ausr = ausrichtung_list.getItem(i);
         
         
            // Ausrichtung und nimm das erste Zeichen der Ausrichtung ( z.B. 'S' fuer "South","Sueden",...)
            if ((ausr.charAt(0) == 'N') |
            (ausr.charAt(0) == 'O') |
            (ausr.charAt(0) == 'S') |
            (ausr.charAt(0) == 'W')) {
            
               nr = Integer.parseInt(nummer_list.getItem(i));
               name = name_list.getItem(i);
               position = new Point3d(pos);
               ausrichtung = ausr.charAt(0);
            }
            else 
               continue;
         
         // Test:
            System.out.println(" Nr.:" + nr);
            System.out.println(" Name:" + name);
            System.out.println(" Pos:" + pos);
            System.out.println(" Ausr:" + ausrichtung);
            //
         
            meinstatus = new Status(ausrichtung, position);
            meineintrag = new ObjektStatus(nr, meinstatus);
            tagesliste.hinzufuegen_eintrag(meineintrag);
         
         
         }
      
      
         // Agenten initialisieren
      
         if (myAgentenliste != null) {
         
            Agent myAgent;
            AgentStatus agentstatus_temp;
            Status status_temp;
         
            java.util.Random r_temp;
            long seed_temp;
            int constraint_x;
            int constraint_y;
            Point3d point_temp;
         
            // Sperrflaechen der Welt
            init_sperrflaeche_welt ();
            // Sperrflaechen der Agenten und Objekte
            tagesliste.init_sperrflaeche (myWelt, myAgentenliste, tagesliste);
         
         
         
            int i = 0;
            while (myAgentenliste.agenten_ausgeben(i) != null) {
            
               seed_temp = 2147483647-(100*(i+1));
               r_temp = new java.util.Random(seed_temp);
            
               constraint_x = myWelt.ausgabe_groesse().ausgabe_x()*myWelt.ausgabe_raster_k();               
               constraint_y = myWelt.ausgabe_groesse().ausgabe_y()*myWelt.ausgabe_raster_k();
            
               point_temp = new Point3d(r_temp.nextInt(constraint_x), r_temp.nextInt(constraint_y), 0);
            
               while (!(tagesliste.ist_frei(point_temp, myWelt, this))) {
               
                  point_temp = new Point3d(r_temp.nextInt(constraint_x), r_temp.nextInt(constraint_y), 0);
               }
            
               status_temp = new Status('N', point_temp);
               agentstatus_temp = new AgentStatus(status_temp, seed_temp);
            
               tagesliste.bewege_Agent(agentstatus_temp, myWelt, this);
            
               myAgent = myAgentenliste.agenten_ausgeben(i);
               myAgent.aendere_status(agentstatus_temp);
            
               myAgentenliste.agenten_aendern(myAgent, i);
            
               i++;
            }
         
         //          Thread t;
         
            for (int j = 0; j < 20; j++) {
            
               i = 0;
               while (myAgentenliste.agenten_ausgeben(i) != null) {
               
                  myAgent = myAgentenliste.agenten_ausgeben(i);
               
                  agentstatus_temp = (myAgent.ausgabe_status());
                  tagesliste.bewege_Agent(agentstatus_temp, myWelt, this);
                  myAgent.aendere_status(agentstatus_temp);
               
                  myAgentenliste.agenten_aendern(myAgent, i);
               
                  //test
                  System.out.println(" ");
                  System.out.println("Agent: " + (myAgentenliste.agenten_ausgeben(i)).ausgabe_id());
                  System.out.println("pos x: " +
                     ((((myAgentenliste.agenten_ausgeben(i)).ausgabe_status()).ausgabe_status()).ausgabe_position()).ausgabe_x());
                  System.out.println("pos y: " + 
                     ((((myAgentenliste.agenten_ausgeben(i)).ausgabe_status()).ausgabe_status()).ausgabe_position()).ausgabe_y());
               
                  i++;
               }
               zeichenflaeche.zeichnen(myWelt,tagesliste,myAgentenliste);
            
            }
         
         }
         else {
            fehler_grunddaten_fehlen f = new fehler_grunddaten_fehlen();
         }
      
      */
      }//GEN-LAST:event_jButton2ActionPerformed
   
      private void nummer_textfActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nummer_textfActionPerformed
      // Add your handling code here:
      }//GEN-LAST:event_nummer_textfActionPerformed
   
      private void name_textfActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_name_textfActionPerformed
      // Add your handling code here:
      }//GEN-LAST:event_name_textfActionPerformed
   
      private void position_textfActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_name_textfActionPerformed
      // Add your handling code here:
      }//GEN-LAST:event_name_textfActionPerformed
   
      private void ausdehnung_textfActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_name_textfActionPerformed
      // Add your handling code here:
      }//GEN-LAST:event_name_textfActionPerformed
   
      private void objektaufstellung_laden_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_objektaufstellung_laden_evt
         new objektaufstellung_laden (new java.awt.Frame (), false).show (); // Add your handling code here:
      }//GEN-LAST:event_objektaufstellung_laden_evt
   
      private void zurueckActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST: event_zurueckActionPerformed
      
         cond = false; //da noch keine anzeige der simulation durchgefuerht wurde 
      
      // Add your handling code here:
         if (0 < aufstellungsindex) {
            aufstellungsindex--;
            seite.setText((aufstellungsindex+1) + "/30");
            aufst2awtlisten(myAufstellungsliste.ausgabe_aufstellung(aufstellungsindex));
            zeichenflaeche.zeichnen(myWelt, myObjektliste, myAufstellungsliste.ausgabe_aufstellung(aufstellungsindex));
         }
      }//GEN-LAST:event_zurueckActionPerformed
   
      private void vorActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_vorActionPerformed
      
         cond = false; //da noch keine anzeige der simulation durchgefuerht wurde 
                // Add your handling code here:
         if (aufstellungsindex < (30-1)) {
            aufstellungsindex++;
            seite.setText((aufstellungsindex+1) + "/30");
            aufst2awtlisten(myAufstellungsliste.ausgabe_aufstellung(aufstellungsindex));
            zeichenflaeche.zeichnen(myWelt, myObjektliste, myAufstellungsliste.ausgabe_aufstellung(aufstellungsindex));
         }
      
      }//GEN-LAST:event_vorActionPerformed
   
   
      private void none (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_none
      // Add your handling code here:
      }//GEN-LAST:event_none
   
      private void welt_fenster_bearbeiten_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_welt_fenster_bearbeiten_evt
      //new welt_fenster (new java.awt.Frame (), false).show ();// Add your handling code here:
         //if (myWelt == null) 
         //   myWelt = new welt_fenster (new java.awt.Frame (), false);
         mywelt_fenster.show();
      
      }//GEN-LAST:event_welt_fenster_bearbeiten_evt
   
      private void welt_fenster_laden_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_welt_fenster_laden_evt
         FileDialog fileDialog = new FileDialog (this, "ffnen...", FileDialog.LOAD);
         fileDialog.show ();
         if (fileDialog.getFile () == null)
            return;
      //fileName = fileDialog.getDirectory () + File.separator + fileDialog.getFile ();// Add your handling code here:
      }//GEN-LAST:event_welt_fenster_laden_evt
   
   
      private void jPanel1ComponentMoved (java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanel1ComponentMoved
      // Add your handling code here:
      }//GEN-LAST:event_jPanel1ComponentMoved
   
   
   
      private void einstellungen_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_einstellungen_evt
         new einstellungen (new java.awt.Frame (), false).show ();
      // Add your handling code here:
      }//GEN-LAST:event_einstellungen_evt
   
   
      //________________________________________________________________________
      // Started den Optimierungszyklus
      private void start_optimierungszyklus_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_start_optimierungszyklus_evt
      
         int i, anzahl, m;
      
      // Abfrage ob bereits eine Simulations durchgefhrt wurde
         if (!simulation)
         {new fehler("Es wurde noch keine Simulation durchgefhrt"); 
            return;}
      
      
         new fenster_anzahl (this, true, einstellungen.anzahl).show ();
         anzahl = fenster_anzahl.anzahl;
         System.out.println(" Optimierungyzklus, Druchlufe: " +anzahl);
      
      // berechnet die freien Positionen (fr Objekte)
      // die entspricht der Lnge des Chromosoms 3
         if (chromlaenge_C1 == -1)
            freie_Positionen();
      
      
         GA myGA = new GA(chromlaenge_C1, myObjektliste.ausgabe_anzahl(), 2147483647, 30);
      
         Individuum parent1, parent2, child;
      
      
         for (m=0; m<anzahl; m++) {
         
         // neue Population
            Population neuepopulation = new Population();
         
         //erzeuge Ausgangspopulation
            Population ausgangspopulation = new Population();
         
         
         // konvertieren aller Aufstellungen
            System.out.println("Generiere Ausgangspopulation:" );
            i=0;        
            while (myAufstellungsliste.ausgabe_aufstellung(i) != null) {
            
            // hinzufgen des betreffenden Individuums
               ausgangspopulation.hinzufuegen(
                  myGA.konvertiere(this, myAufstellungsliste.ausgabe_aufstellung(i)));
            
               i++;
            }   
         
         // berechnet die Summe aller Fitnesswerte, fr die Selektion
            ausgangspopulation.berechne_summe();
         
         // erzeugt eine neue Popultion aus der Ausgangspopulation
         
            while (i >= 4) {
            // selektiert zwei Individuuen, speichert sie in der
            // neuen Population und speichert zwei neue Individuen 
            // (durch Crossover entstanden) ebenfalls.
               parent1 = ausgangspopulation.selektiere();
               parent2 = ausgangspopulation.selektiere();
            
               neuepopulation.hinzufuegen(parent1);
               neuepopulation.hinzufuegen(parent2);
            
            // Crossover
               child = new Individuum(parent1, parent2);
               neuepopulation.hinzufuegen(child);
               child = new Individuum(parent2, parent1);
               neuepopulation.hinzufuegen(child);
            
               i = i-4; 
            }
         
         // auffllen der neuen Population, falls noch welche fehlen solten
            while (neuepopulation.size() < ausgangspopulation.size()) {
               parent1 = ausgangspopulation.selektiere();
               parent1.mutiere();
               neuepopulation.hinzufuegen(parent1);     
            }
         
         
            System.out.println("Mutieren der Population");
         // Mutation
            for (i=0; i < neuepopulation.size(); i++)
               if (myGA.mutiere(neuepopulation.size()))
                  neuepopulation.ausgeben(i).mutiere();
         
         
           // Abfrage, ob das Programm im Testmodus gestartet wurde
            if (test) {
            
               System.out.println("erzeuge eine neue Aufstellungsliste " + neuepopulation.size());
            	// erzeuge aus den neuen Individuuen eine neue Aufstellungsliste
               for (i=0; i< neuepopulation.size(); i++) {
                  myAufstellungsliste.aendere_aufstellung(
                     myGA.konvertiere(neuepopulation.ausgeben(i), this), i);
               }   
            }
            else {
               Aufstellungsliste temp_liste = new Aufstellungsliste();
            
            	// erzeuge aus den neuen Individuuen eine temporre Aufstellungsliste
               for (i=0; i< neuepopulation.size(); i++) {
                  temp_liste.hinzufuegen_aufstellung(
                     myGA.konvertiere(neuepopulation.ausgeben(i), this));
               }
            
            	// Simulieren vernderter Aufstellungen
               for (i=0; i< neuepopulation.size(); i++) {
                  if (temp_liste.ausgabe_aufstellung(i).ausgabe_fitness() == -1) {
                     simuliere(temp_liste.ausgabe_aufstellung(i), agentenbewegungen, 0);
                     temp_liste.ausgabe_aufstellung(i).erzeuge_fitness();
                     System.out.println(" Fitness der Aufstellung (GA) " + i + " : " +
                        temp_liste.ausgabe_aufstellung(i).ausgabe_fitness());
                  }      
                  else
                     System.out.println(" Fitness der Aufstellung (GA) " + i + " : " +
                        temp_liste.ausgabe_aufstellung(i).ausgabe_fitness());
               }    
            
            
            	// rotieren der Aufstellungsliste 
               for (i=0; i< neuepopulation.size()-1; i++) {
                  myAufstellungsliste.aendere_aufstellung(
                     myAufstellungsliste.ausgabe_aufstellung(i+1), i);
               }   
            
            	// bestes Individuum suchen
               int max = 0, max_id = 0;
               for (i=0; i< neuepopulation.size()-1; i++)
                  if (max <= temp_liste.ausgabe_aufstellung(i).ausgabe_fitness()) {
                     max =  temp_liste.ausgabe_aufstellung(i).ausgabe_fitness();
                     max_id = i;
                  }
            
            	// bestes Individuum suchen
               System.out.println("   beste Austellung " + max_id + " Fitness: " +
                  temp_liste.ausgabe_aufstellung(max_id).ausgabe_fitness());
               myAufstellungsliste.aendere_aufstellung( 
                  temp_liste.ausgabe_aufstellung(max_id), i);		
            }
         
         
            System.out.println("Simulieren vernderter Aufstellungen");
         // Simulieren vernderter Aufstellungen
            for (i=0; i< neuepopulation.size(); i++) {
               if (myAufstellungsliste.ausgabe_aufstellung(i).ausgabe_fitness() == -1) {
                  simuliere(myAufstellungsliste.ausgabe_aufstellung(i), agentenbewegungen, 0);
                  myAufstellungsliste.ausgabe_aufstellung(i).erzeuge_fitness();
                  System.out.println("Fitness der neuen Aufstellung " + i + " : " +
                     myAufstellungsliste.ausgabe_aufstellung(i).ausgabe_fitness());
               }      
               //else
                  //System.out.println("Fitness der Aufstellung " + i + " : " +
                     //myAufstellungsliste.ausgabe_aufstellung(i).ausgabe_fitness());
            }           
         
         
         
         
         
         }
      
      /*
      System.out.println("konvertiere1");
      Individuum myIndividuum = myGA.konvertiere(this, myAufstellungsliste.ausgabe_aufstellung(aufstellungsindex));
          
      System.out.println("konvertiere2");
      myAufstellungsliste.aendere_aufstellung(
        myGA.konvertiere(myIndividuum, this), aufstellungsindex+1);
        
      
      
      
      
      
      
      
      i=0;      
         while (myAufstellungsliste.ausgabe_aufstellung(i) != null) {
         // derzeit agentenbewegungen Agentenbewegungen (jeder Agent!)
         // keine graphische Anzeige      (0)! 
            simuliere(i, agentenbewegungen, 0);
            // berechne den fitnesswert und lsche Guthabenliste
            myAufstellungsliste.ausgabe_aufstellung(i).erzeuge_fitness();
            
            System.out.println("Aufstellung " + i + " simuliert: Fitnesswert " +
                myAufstellungsliste.ausgabe_aufstellung(i).ausgabe_fitness() );
            i++;
         } 
      
      
      
      
      
      
      //////////////////////////////////
      // AUSGABE
      BitSet temp;
      int[] tempi;
      int k;
      
      System.out.println("1. Individuum");
        
      System.out.println("L:" + myIndividuum.chrom1().laenge());
      temp = myIndividuum.chrom1().chrom();
      for (k=0; k<myIndividuum.chrom1().laenge(); k++) {
             if (temp.get(k))
                System.out.print("1");
             else System.out.print("0");
      }
      System.out.println("");           
      
      System.out.println("L:" + myIndividuum.chrom2().chrom().length);
      tempi = myIndividuum.chrom2().chrom();
      for (k=0; k<tempi.length; k++) {
             System.out.print(tempi[k] + " ");
      }
      System.out.println("");           
        
      System.out.println("L:" + myIndividuum.chrom3().laenge());
      temp = myIndividuum.chrom3().chrom();
      for (k=0; k<myIndividuum.chrom3().laenge(); k++) {
             if (temp.get(k))
                System.out.print("1");
             else System.out.print("0");
      }
      System.out.println("");      
      ////////////////////////////////////      
      
      */
      
      }//GEN-LAST:event_start_optimierungszyklus_evt
   
   
   
      //________________________________________________________________________
      // Simulieren aller Aufstellung
      private void start_simulation_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_start_simulation_evt
      
         int i;
      
        // Simulation wurde durchgefhrt        
         simulation = true;
      
         // berechne die Anzahl der Agentenbewegungen in Abhngigkeit von
         // der Weltgroesse
         if (agentenbewegungen == -1)
            agentenbewegungen = 3*myWelt.ausgabe_raster_k()*
               myWelt.ausgabe_groesse().ausgabe_x()*
               myWelt.ausgabe_groesse().ausgabe_x();                            
      
         i=0;   
         while (myAufstellungsliste.ausgabe_aufstellung(i) != null) {
         // derzeit agentenbewegungen Agentenbewegungen (jeder Agent!)
         // keine graphische Anzeige      (0)! 
            simuliere(myAufstellungsliste.ausgabe_aufstellung(i), agentenbewegungen, 0);
            // berechne den fitnesswert und lsche Guthabenliste
            myAufstellungsliste.ausgabe_aufstellung(i).erzeuge_fitness();
         
            System.out.println("Aufstellung " + i + " simuliert: Fitnesswert " +
               myAufstellungsliste.ausgabe_aufstellung(i).ausgabe_fitness() );
            i++;
         } 
      
      
        // AWt-Listen aktualisieren
         aufst2awtlisten(myAufstellungsliste.ausgabe_aufstellung(aufstellungsindex));
      
        // Und Zeichen...
         zeichenflaeche.zeichnen(myWelt, myObjektliste, myAufstellungsliste.ausgabe_aufstellung(aufstellungsindex));
      
      }//GEN-LAST:event_start_simulation_evt
       //_______________________________________________________________________
   
      private void hilfe_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_hilfe_evt
      // Add your handling code here:
      }//GEN-LAST:event_hilfe_evt
   
      private void optionen_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_optionen_evt
      // Add your handling code here:
      }//GEN-LAST:event_optionen_evt
   
      private void start_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_start_evt
      // Add your handling code here:
      }//GEN-LAST:event_start_evt
   
      private void agenten_bearbeiten_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_agenten_bearbeiten_evt
      //new agenten_fenster (new java.awt.Frame (), false).show (); // Add your handling code here:
      
         //if (myAgenten == null)
           // myAgenten = new agenten_fenster (new java.awt.Frame (), false);
         myagenten_fenster.show();
      
      }//GEN-LAST:event_agenten_bearbeiten_evt
   
      private void agenten_laden (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_agenten_laden
         FileDialog fileDialog = new FileDialog (this, "ffnen...", FileDialog.LOAD);
         fileDialog.show ();
         if (fileDialog.getFile () == null)
            return;
      //fileName = fileDialog.getDirectory () + File.separator + fileDialog.getFile ();// Add your handling code here:
      }//GEN-LAST:event_agenten_laden
   
      private void objekte_bearbeiten_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_objekte_bearbeiten_evt
      //new objekte_fenster (new java.awt.Frame (), false).show ();// Add your handling code here:
      
         //if (myObjekte == null)
           // myObjekte = new objekte_fenster (new java.awt.Frame (), false);
         myobjekte_fenster.show();
      
      }//GEN-LAST:event_objekte_bearbeiten_evt
   
      private void objekte_laden_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_objekte_laden_evt
         FileDialog fileDialog = new FileDialog (this, "ffnen...", FileDialog.LOAD);
         fileDialog.show ();
         if (fileDialog.getFile () == null)
            return;
      //fileName = fileDialog.getDirectory () + File.separator + fileDialog.getFile ();// Add your handling code here:
      }//GEN-LAST:event_objekte_laden_evt
   
      private void agenten_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_agenten_evt
      // Add your handling code here:
      }//GEN-LAST:event_agenten_evt
   
      private void objekte_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_objekte_evt
      // Add your handling code here:
      }//GEN-LAST:event_objekte_evt
   
      private void welt_fenster_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_welt_fenster_evt
      // Add your handling code here:
      }//GEN-LAST:event_welt_fenster_evt
   
      private void grunddaten_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_grunddaten_evt
      // Add your handling code here:
      }//GEN-LAST:event_grunddaten_evt
   
      private void datei_beenden_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_datei_beenden_evt
      
         System.exit (0); // Add your handling code here:
      }//GEN-LAST:event_datei_beenden_evt
   
      private void datei_speichern_unter_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_datei_speichern_unter_evt
         FileDialog fileDialog = new FileDialog (this, "Speichern unter...", FileDialog.SAVE);
         fileDialog.show ();
         if (fileDialog.getFile () == null)
            return;
      //fileName = fileDialog.getDirectory () + File.separator + fileDialog.getFile (); // Add your handling code here:
      }//GEN-LAST:event_datei_speichern_unter_evt
   
      private void datei_speichern_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_datei_speichern_evt
         FileDialog fileDialog = new FileDialog (this, "Speichern...", FileDialog.SAVE);
         fileDialog.show ();
         if (fileDialog.getFile () == null)
            return;
      //fileName = fileDialog.getDirectory () + File.separator + fileDialog.getFile ();
      // Add your handling code here:
      }//GEN-LAST:event_datei_speichern_evt
   
      private void jMenuItem2ActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
      // Add your handling code here:
      }//GEN-LAST:event_jMenuItem2ActionPerformed
   
      private void datei_neu_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_datei_neu_evt
      // Add your handling code here:
      }//GEN-LAST:event_datei_neu_evt
   
      private void datei_evt (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_datei_evt
      // Add your handling code here:
      }//GEN-LAST:event_datei_evt
   
   /** Exit the Application */
      private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
         System.exit (0);
      }//GEN-LAST:event_exitForm
   
        /*   
        Die naechsten fuenf Methoden dienen dazu, dass eine Selektion in einer der fuenf Listen
        der Objektaufstellung auf alle Listen angewendet wird und die selektierten Elemente
        jeweils im dazugehoerigen Textfeld darueber erscheinen.         
        */
      private void nummer_listItemEvent(java.awt.event.ItemEvent evt) {
         if (evt.getStateChange() == java.awt.event.ItemEvent.SELECTED) {
         
            nummer_textf.setText(nummer_list.getSelectedItem());
         
            name_list.select(nummer_list.getSelectedIndex());
            name_textf.setText(name_list.getSelectedItem());
         
            position_list.select(nummer_list.getSelectedIndex());
            position_textf.setText(position_list.getSelectedItem());
         
            ausdehnung_list.select(nummer_list.getSelectedIndex());
            ausdehnung_textf.setText(ausdehnung_list.getSelectedItem());
         
            ausrichtung_list.select(nummer_list.getSelectedIndex());
            ausrichtung_choice.select(ausrichtung_list.getSelectedItem());
         }
      }
   
      private void name_listItemEvent(java.awt.event.ItemEvent evt) {
         if (evt.getStateChange() == java.awt.event.ItemEvent.SELECTED) {
         
            name_textf.setText(name_list.getSelectedItem());
         
            nummer_list.select(name_list.getSelectedIndex());
            nummer_textf.setText(nummer_list.getSelectedItem());
         
            position_list.select(name_list.getSelectedIndex());
            position_textf.setText(position_list.getSelectedItem());
         
            ausdehnung_list.select(name_list.getSelectedIndex());
            ausdehnung_textf.setText(ausdehnung_list.getSelectedItem());
         
            ausrichtung_list.select(name_list.getSelectedIndex());
            ausrichtung_choice.select(ausrichtung_list.getSelectedItem());
         }
      }
   
      private void position_listItemEvent(java.awt.event.ItemEvent evt) {
         if (evt.getStateChange() == java.awt.event.ItemEvent.SELECTED) {
         
            position_textf.setText(position_list.getSelectedItem());
         
            nummer_list.select(position_list.getSelectedIndex());
            nummer_textf.setText(nummer_list.getSelectedItem());
         
            name_list.select(position_list.getSelectedIndex());
            name_textf.setText(name_list.getSelectedItem());
         
            ausdehnung_list.select(position_list.getSelectedIndex());
            ausdehnung_textf.setText(ausdehnung_list.getSelectedItem());
         
            ausrichtung_list.select(position_list.getSelectedIndex());
            ausrichtung_choice.select(ausrichtung_list.getSelectedItem());
         }
      }
   
      private void ausdehnung_listItemEvent(java.awt.event.ItemEvent evt) {
         if (evt.getStateChange() == java.awt.event.ItemEvent.SELECTED) {
         
            ausdehnung_textf.setText(ausdehnung_list.getSelectedItem());
         
            nummer_list.select(ausdehnung_list.getSelectedIndex());
            nummer_textf.setText(nummer_list.getSelectedItem());
         
            name_list.select(ausdehnung_list.getSelectedIndex());
            name_textf.setText(name_list.getSelectedItem());
         
            position_list.select(ausdehnung_list.getSelectedIndex());
            position_textf.setText(position_list.getSelectedItem());
         
            ausrichtung_list.select(ausdehnung_list.getSelectedIndex());
            ausrichtung_choice.select(ausrichtung_list.getSelectedItem());
         }
      }
   
      private void ausrichtung_listItemEvent(java.awt.event.ItemEvent evt) {
         if (evt.getStateChange() == java.awt.event.ItemEvent.SELECTED) {
         
            ausrichtung_choice.select(ausrichtung_list.getSelectedItem());
         
            nummer_list.select(ausrichtung_list.getSelectedIndex());
            nummer_textf.setText(nummer_list.getSelectedItem());
         
            name_list.select(ausrichtung_list.getSelectedIndex());
            name_textf.setText(name_list.getSelectedItem());
         
            position_list.select(ausrichtung_list.getSelectedIndex());
            position_textf.setText(position_list.getSelectedItem());
         
            ausdehnung_list.select(ausrichtung_list.getSelectedIndex());
            ausdehnung_textf.setText(ausdehnung_list.getSelectedItem());
         }
      }
   
   
   
   
   //_________________________________________________________________________  
   // Simualtion einer bestimmten Aufstellung
   // ein-Prameter:		liste 			Aufstellungsliste
   //    				aufstellung             Nummer der Aufstellung
   //                   anzahl                  Anzahl der Bewegungen der Agenten
   //                   graphisch               graphisches Anzeigeintervall (0-100)            
   //                   					    0 ... keine Anzeige; 100 alles
      public void simuliere (Objektaufstellung myaufst, int anzahl, int graphisch) {
      
      // von Markus eingefuegt
         int i;
         java.util.Random r_temp;
         long seed_temp;
         int constraint_x;
         int constraint_y;
         Status status_temp;
         Point3d point_temp;
         Agent myAgent;
         AgentStatus agentstatus_temp;
         int maximal = myAgentenliste.size();
         int wieviele = einstellungen.agenten_bei_simulation;
         int save_agenten[] = new int [maximal];
      
      
      // Fehlerabfrage
         if (myAgentenliste == null
         || myObjektliste == null || myaufst == null)
            return;
      
      
      // Reinitialisieren der Aufstellung (fr Wiederholbarkeit)
         myaufst.reinit();
      
      // Sperrflaechen initialisieren
         init_sperrflaeche_welt();
      
      // Sperrflaechen der Aufstellung initialisieren
      // (es sind noch keine Agenten positioniert)
         myaufst.init_sperrflaeche(myWelt, null, this);
      
      // Objekte positionieren, bei denen auto angegeben wurde
      
         constraint_x = myWelt.ausgabe_groesse().ausgabe_x();               
         constraint_y = myWelt.ausgabe_groesse().ausgabe_y();
      
         int id;
         char ausr = 'N';
         int pos_x, pos_y, pos_z;
         Point3d position, obj_pos_von, obj_pos_bis;
      
        // Grafische Aufstellungsliste durchlaufen, und nach Positionen = auto suchen
         for (i = 0; i < position_list.getItemCount(); i++) {
         
                // Falls auto, suche Zufaellige Position fuer Objekt
            if (position_list.getItem(i).equals("auto")) {
            
               seed_temp = 2147483647-(100*(i+1));
               r_temp = new java.util.Random(seed_temp);
            
               id = Integer.parseInt(nummer_list.getItem(i));
            
                // Berechne Objektposition in Raster und Ausdehnung des Objektes
               pos_x = r_temp.nextInt(constraint_x);
               pos_y = r_temp.nextInt(constraint_y);
               pos_z = 0;
            
               position = new Point3d(pos_x,pos_y,pos_z);
               obj_pos_von = new Point3d(pos_x * myWelt.ausgabe_raster_k(),
                  pos_y * myWelt.ausgabe_raster_k(),
                  pos_z);
               obj_pos_bis = new Point3d((pos_x+myObjektliste.objekt_ausgeben_id(id).ausgabe_groesse().ausgabe_x()) * myWelt.ausgabe_raster_k(), 
                  (pos_y+myObjektliste.objekt_ausgeben_id(id).ausgabe_groesse().ausgabe_y()) * myWelt.ausgabe_raster_k(),
                  pos_z);
            
                // Waehrend keine freie Stelle gefunden, suche weiter nach neuer Position
               while (!(myaufst.ist_frei(obj_pos_von,obj_pos_bis,myWelt,this)))  {
               
                  pos_x = r_temp.nextInt(constraint_x);
                  pos_y = r_temp.nextInt(constraint_y);
                  pos_z = 0;
               
                  position = new Point3d(pos_x,pos_y,pos_z);
                  obj_pos_von = new Point3d(pos_x * myWelt.ausgabe_raster_k(),
                     pos_y * myWelt.ausgabe_raster_k(),
                     pos_z);
                  obj_pos_bis = new Point3d((pos_x+myObjektliste.objekt_ausgeben_id(id).ausgabe_groesse().ausgabe_x()) * myWelt.ausgabe_raster_k(), 
                     (pos_y+myObjektliste.objekt_ausgeben_id(id).ausgabe_groesse().ausgabe_y()) * myWelt.ausgabe_raster_k(),
                     pos_z);
               }
            
                //freie Position gefunden: Aendere Position und zufaellige Ausrichtung
               if ((myaufst != null) && (myaufst.ausgabe_eintrag_id(id) != null) &&
               (myaufst.ausgabe_eintrag_id(id).ausgabe_status() != null)) {
               
                  myaufst.ausgabe_eintrag_id(id).ausgabe_status().aendere_position(position);
               
                  ausr = (ausrichtung_choice.getItem(r_temp.nextInt(4)+1)).charAt(0); 
                  myaufst.ausgabe_eintrag_id(id).ausgabe_status().aendere_ausrichtung(ausr);
               
                  myaufst.init_sperrflaeche(myWelt, null, this);
               }
            }
         }
      
      
      // Agenten positionieren
      //agenten_bei_simulation
         i=0;
         while (myAgentenliste.agenten_ausgeben(i) != null) {
         
            myAgent = myAgentenliste.agenten_ausgeben(i);
         
         // Guthaben speichern
            save_agenten[i] = myAgent.ausgabe_guthaben();
         
                // Entscheidung ob Agent positionierte werden soll
         
            if (wieviele != 0) {
            // unterscheidung, wegen genauigkeit
               if (   (wieviele < 50 && (i % (int)(100/wieviele)) == 0)
               || (wieviele > 50 && (i % (int)(100/(100-wieviele)) != 0))){
               
                  //System.out.println(" stelle Agent " + i + " auf: ");
               
                  seed_temp = 2147483647-(100*(i+1));
                  r_temp = new java.util.Random(seed_temp);
               
                  constraint_x = myWelt.ausgabe_groesse().ausgabe_x()*myWelt.ausgabe_raster_k();               
                  constraint_y = myWelt.ausgabe_groesse().ausgabe_y()*myWelt.ausgabe_raster_k();
               
                  point_temp = new Point3d(r_temp.nextInt(constraint_x), r_temp.nextInt(constraint_y), 0);
               
               // suche freie Position
                  while (!(myaufst.ist_frei(point_temp, myWelt, this))) {
                  
                     point_temp = new Point3d(r_temp.nextInt(constraint_x), r_temp.nextInt(constraint_y), 0);
                  }
               
               // neue Position des Agenten
                  status_temp = new Status('N', point_temp);
                  agentstatus_temp = new AgentStatus(status_temp, seed_temp);
               
               // Agent positionieren                       
                  myAgent.aendere_status(agentstatus_temp);
               }
            }
            
            // Status des Agenten lschen
            else myAgent.aendere_status(null);
         
         // naechster Agent
            i++;
         }
      
      
      // Agenten bewegen              
         for (i=0; i < anzahl; i++){
            myaufst.bewege_Agenten(myAgentenliste, myWelt, this);
         
         // je nach Anzeigeintervall graphisch aktualisieren
            if (graphisch != 0) {
            // unterscheidung, wegen genauigkeit
               //if (   (graphisch < 50 && (i % (int)(100/graphisch)) == 0)
               //|| (graphisch > 50 && (i % (int)(100/(100-graphisch)) != 0))){
            
            
               // aktualisiere
               System.out.println("Bewegung Nr. " + i);
               try {
                  Thread.sleep(((int)(graphisch)));
               }
                  catch(InterruptedException e) {
                     System.out.println("Thread wurde unterbrochen!!");
                  }	
               zeichenflaeche.zeichnen(myWelt,myObjektliste,myaufst,myAgentenliste);
               zeichenflaeche.update(zeichenflaeche.getGraphics());
               //	zeichenflaeche.paint(zeichenflaeche.getGraphics());
            }
         }
      
      
      // Guthaben wiederherstellen
         i=0;
         while (myAgentenliste.agenten_ausgeben(i) != null) {
            myAgentenliste.agenten_ausgeben(i).aendere_guthaben_abs(
               save_agenten[i]);
            i++;
         }
      
      }
   //_____________________________________________________________________________     
   
   
   
     //_____________________________________________________________________________     
        // Liefert die Anzahl der besetzten Positioen bis zu einem bestimmten Punkt
      public int besetzte(Point3d pos) {
      
         Point3d temp, von, bis;
         int k, dim_x, dim_y, j, x, y;
         int besetzt = 0;
      
         temp = myWelt.ausgabe_groesse();          
         k = myWelt.ausgabe_raster_k(); 
         dim_x = temp.ausgabe_x(); 
         dim_y = temp.ausgabe_y(); 
      
      // Spalten durchlaufen 
         for(y=0; y < dim_y; y ++) 
         // Zeilen durchlaufen 
            for(x=0; x < dim_x; x++) {
               von = new Point3d(x*k,y*k,0);
               bis = new Point3d(x*k+k,y*k+k,0);                
                // Ist die Stelle bereits erreicht:
               if (pos.ausgabe_x() == x && pos.ausgabe_y() == y)
                  return besetzt;
                // Falls die Flaeche frei ist erhoehe
               if (!ist_frei(von, bis))
                  besetzt++; 
            }       
      
         return besetzt;
      }   
   
   
   
        //_____________________________________________________________________________     
        // Liefert die Anzahl der Positioen, an welchen Objekte positioniert werden
        // knnen;
      public void freie_Positionen() {
      
         Point3d temp, von, bis;
         int k, dim_x, dim_y, j, x, y;
         int anzahl = 0;
      
         temp = myWelt.ausgabe_groesse();          
         k = myWelt.ausgabe_raster_k(); 
         dim_x = temp.ausgabe_x(); 
         dim_y = temp.ausgabe_y(); 
      
      // Zeilen durchlaufen 
         for(y=0; y < dim_y; y ++) 
         // Spalten durchlaufen 
            for(x=0; x < dim_x; x++) {
               von = new Point3d(x*k,y*k,0);
               bis = new Point3d(x*k+k,y*k+k,0);                
                // Falls die Flaeche frei ist erhoehe
               if (ist_frei(von, bis))
                  anzahl++; 
            }       
      
         chromlaenge_C1 = anzahl;
      }   
   
   
        //_____________________________________________________________________________     
        // berprft innerhalb einer bestimmten flche ein Objekt positioniert werden
        // kann (andere Objekte und Agenten werden nicht bercksichtigt!)
      public boolean ist_frei(Point3d von, Point3d bis) {
      
         Point3d temp;
      
         int dim_x = myWelt.ausgabe_groesse().ausgabe_x()*myWelt.ausgabe_raster_k();
      
      // derzeitige Objektaufstellung
         Objektaufstellung myaufst = myAufstellungsliste.ausgabe_aufstellung(aufstellungsindex);
      
      // berprfe, ob alle ntigen BitSets vorhaden sind
         if (myaufst.ausgabe_ausgaenge() == null)
            myaufst.init_sperrflaeche(myWelt, null, this);
      
      
         for (int yi = von.ausgabe_y(); yi < bis.ausgabe_y(); yi++) {
            for (int xi = von.ausgabe_x(); xi < bis.ausgabe_x(); xi++) {
               temp = new Point3d(xi,yi,0);
               if (sperrflaeche_w.get(yi*dim_x + xi) 
               || myaufst.ist_ausgang(temp, myWelt))
                  return false;
            }
         }
      
         return true;
      } 
   
   
   
   //__________________________________________________________________________ 
   
   
   
   // Variables declaration - do not modify//GEN-BEGIN:variables
    // Beginn toolbar
      private javax.swing.JPanel jPanel3;
      private javax.swing.JPanel jPanel1;
      private javax.swing.JPanel jPanel2;
      private javax.swing.JToolBar jToolBar1;
      private javax.swing.JButton zurueck;
      private javax.swing.JLabel seite;
      private javax.swing.JButton vor;
      private javax.swing.JSeparator jSeparator1;
      private javax.swing.JButton details;
      private javax.swing.JSeparator jSeparator2;
      private javax.swing.JButton aufstellung_simulieren;
    // end toolbar
   
   
      private javax.swing.JPanel objektaufstellung;
      private javax.swing.JPanel welt_fenster;
      private javax.swing.JPanel platzhalter_oben;
      private javax.swing.JPanel liste;
      private javax.swing.JPanel eingabe;
      private javax.swing.JPanel nummer_p;
      private javax.swing.JPanel name_p;
      private javax.swing.JPanel position_p;
      private javax.swing.JPanel ausdehnung_p;
      private javax.swing.JPanel ausrichtung_p;
      private javax.swing.JPanel objbuttons_p;
      //private java.awt.List nummer_list;
      private java.awt.List name_list;
      private java.awt.List position_list;
      private java.awt.List ausdehnung_list;
      private java.awt.List ausrichtung_list;
      private javax.swing.JPanel textfelder;
      private javax.swing.JPanel beschriftung;
      private javax.swing.JPanel platzhalter;
      private javax.swing.JTextField nummer_textf;
      private javax.swing.JTextField name_textf;
      private javax.swing.JTextField position_textf;
      private javax.swing.JTextField ausdehnung_textf;
      private java.awt.Choice ausrichtung_choice;
      private javax.swing.JLabel nummer_beschr;
      private javax.swing.JLabel name_beschr;
      private javax.swing.JLabel position_beschr;
      private javax.swing.JLabel ausdehnung_beschr;
      private javax.swing.JLabel ausrichtung_beschr;
      private javax.swing.JButton uebernehmen;
      private javax.swing.JButton allehinzufuegen;
      private javax.swing.JButton hinzufuegen;
      private javax.swing.JMenuBar Menue;
      private javax.swing.JMenu jMenu1;
      private javax.swing.JMenu jMenu2;
      private javax.swing.JMenu jMenu6;
      private javax.swing.JMenu jMenu7;
      private javax.swing.JMenu jMenu8;
      private javax.swing.JMenuItem jMenuItem1;
      private javax.swing.JMenuItem oeffnen;
      private javax.swing.JMenuItem jMenuItem3;
      private javax.swing.JMenuItem jMenuItem4;
      private javax.swing.JMenuItem jMenuItem5;
      private javax.swing.JMenu jMenu3;
      private javax.swing.JMenu jMenu4;
      private javax.swing.JMenu jMenu5;
      private javax.swing.JMenuItem jMenuItem6;
      private javax.swing.JMenuItem jMenuItem7;
      private javax.swing.JMenuItem jMenuItem13;
      private javax.swing.JMenuItem jMenuItem16;
      private javax.swing.JMenuItem jMenuItem15;
      private javax.swing.JMenuItem jMenuItem17;
      private javax.swing.JMenuItem jMenuItem18;
      private javax.swing.JMenuItem jMenuItem21;
      private javax.swing.JMenuItem jMenuItem8;
      private javax.swing.JMenuItem jMenuItem25;
      private javax.swing.JMenuItem jMenuItem20;
   // End of variables declaration//GEN-END:variables
   
   
   
      static boolean test = false;
   
   
      public static void main(java.lang.String[] args) {
      
      // Abfrage, ob das Programm im Testmodus gestartet werden soll oder nicht
         if (args.length > 0)
            if (args[0].equals("-test"))
            {test = true; System.out.println("Testmodus!");}
      
      //hauptfenster starten:
         new hauptfenster ().show ();
      
      }
   
   }
